#include<inc/tm4c123gh6pm.h>
#include <stdint.h>
#include <stdbool.h>
#include "inc/hw_gpio.h"
#include "inc/hw_types.h"
#include "inc/hw_memmap.h"
#include "driverlib/sysctl.h"
#include "driverlib/pin_map.h"
#include "driverlib/gpio.h"
#include "driverlib/pwm.h"
#include "driverlib/adc.h"
#include "driverlib/sysctl.h"
#include<driverlib/interrupt.h>
#include<driverlib/timer.h>
void PortFIntHandler(void);
void PortFInit(void);
volatile unsigned long ui32Loop,Count;
volatile unsigned long Old_Count,Elapsed_Count;
volatile unsigned long New_Count=0;
float freq,speed,speedref,error;
volatile unsigned long ha,hb,hc;
int main(void){
	error=0.00;
	speedref=1200.00;
	SysCtlClockSet(SYSCTL_SYSDIV_2_5 | SYSCTL_USE_PLL |   SYSCTL_OSC_MAIN | SYSCTL_XTAL_16MHZ);
		   SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOD);
		   SysCtlDelay(3);
		   SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOE);
		   SysCtlDelay(3);
		   SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOA);
		   SysCtlDelay(3);
		   GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_0|GPIO_PIN_1|GPIO_PIN_2|GPIO_PIN_3);
		   GPIOPinTypeGPIOOutput(GPIO_PORTE_BASE, GPIO_PIN_1|GPIO_PIN_2);
		   GPIOPinTypeGPIOInput(GPIO_PORTA_BASE, GPIO_PIN_5|GPIO_PIN_6|GPIO_PIN_7);
	SysCtlPeripheralEnable(SYSCTL_PERIPH_TIMER0);
		SysCtlDelay(3);
		TimerDisable(TIMER0_BASE,TIMER_A);
		TimerConfigure(TIMER0_BASE, TIMER_CFG_PERIODIC_UP);
		 TimerLoadSet(TIMER0_BASE, TIMER_A, 0x00FFFFFF);
		TimerEnable(TIMER0_BASE, TIMER_A);
      PortFInit(); // initialize GPIO Port F interrupt

   while(1)
   {
	   ha=GPIOPinRead(GPIO_PORTA_BASE,GPIO_PIN_5) & 0x20;
	   	        	   hb=GPIOPinRead(GPIO_PORTA_BASE,GPIO_PIN_6) & 0x40;
	   	        	   hc=GPIOPinRead(GPIO_PORTA_BASE,GPIO_PIN_7) & 0x80;
speed=speed+1;
	   	        	   if(ha==0x20 && hb==0x40 && hc==0x80)  //111
	   	        	      	      {
	   	        	      	           	  GPIOPinWrite(GPIO_PORTD_BASE,GPIO_PIN_1, false);
	   	        	      	           	  GPIOPinWrite(GPIO_PORTD_BASE,GPIO_PIN_0, false);
	   	        	      	           	  GPIOPinWrite(GPIO_PORTD_BASE,GPIO_PIN_3, false);
	   	        	      	           	  GPIOPinWrite(GPIO_PORTE_BASE,GPIO_PIN_2, false);
	   	        	      	           	  GPIOPinWrite(GPIO_PORTD_BASE,GPIO_PIN_2, false);
	   	        	      	           	  GPIOPinWrite(GPIO_PORTE_BASE,GPIO_PIN_1, false);
	   	        	      	           	}
	   	        	   if(ha!=0x20 && hb!=0x40 && hc!=0x80)  //000
	   	        	       	      	      {
	   	        	       	      	           	  GPIOPinWrite(GPIO_PORTD_BASE,GPIO_PIN_1, false);
	   	        	       	      	           	  GPIOPinWrite(GPIO_PORTD_BASE,GPIO_PIN_0, false);
	   	        	       	      	           	  GPIOPinWrite(GPIO_PORTD_BASE,GPIO_PIN_3, false);
	   	        	       	      	           	  GPIOPinWrite(GPIO_PORTE_BASE,GPIO_PIN_2, false);
	   	        	       	      	           	  GPIOPinWrite(GPIO_PORTD_BASE,GPIO_PIN_2, false);
	   	        	       	      	           	  GPIOPinWrite(GPIO_PORTE_BASE,GPIO_PIN_1, false);
	   	        	       	      	           	}
	   	        	   if(ha==0x20 && hb==0x40 && hc!=0x80) //110
	   	        	      {
	   	        	   	   GPIOPinWrite(GPIO_PORTD_BASE,GPIO_PIN_0, false);
	   	        	   	   GPIOPinWrite(GPIO_PORTD_BASE,GPIO_PIN_1, false);
	   	        	   	   GPIOPinWrite(GPIO_PORTE_BASE,GPIO_PIN_2, false);
	   	        	   	   GPIOPinWrite(GPIO_PORTE_BASE,GPIO_PIN_1, false);
	   	        	   	   GPIOPinWrite(GPIO_PORTD_BASE,GPIO_PIN_3, GPIO_PIN_3);
	   	        	   	   GPIOPinWrite(GPIO_PORTD_BASE,GPIO_PIN_2, GPIO_PIN_2);
	   	        	      }
	   	        	      if(ha!=0x20 && hb==0x40 && hc!=0x80) //010
	   	        	      {


	   	        	   	  GPIOPinWrite(GPIO_PORTD_BASE,GPIO_PIN_2, false);
	   	        	   	  GPIOPinWrite(GPIO_PORTE_BASE,GPIO_PIN_1, false);
	   	        	   	  GPIOPinWrite(GPIO_PORTE_BASE,GPIO_PIN_2, false);
	   	        	   	  GPIOPinWrite(GPIO_PORTD_BASE,GPIO_PIN_1, GPIO_PIN_1);
	   	        	   	  GPIOPinWrite(GPIO_PORTD_BASE,GPIO_PIN_3, GPIO_PIN_3);
	   	        	   	}
	   	        	      if(ha!=0x20 && hb==0x40 && hc==0x80)  //011
	   	        	      {
	   	        	   	   GPIOPinWrite(GPIO_PORTD_BASE,GPIO_PIN_0, false);
	   	        	   	   GPIOPinWrite(GPIO_PORTD_BASE,GPIO_PIN_2, false);
	   	        	   	   GPIOPinWrite(GPIO_PORTD_BASE,GPIO_PIN_3, false);
	   	        	   	   GPIOPinWrite(GPIO_PORTE_BASE,GPIO_PIN_1, false);
	   	        	   	   GPIOPinWrite(GPIO_PORTD_BASE,GPIO_PIN_1, GPIO_PIN_1);
	   	        	   	   GPIOPinWrite(GPIO_PORTE_BASE,GPIO_PIN_2, GPIO_PIN_2);
	   	        	      }
	   	        	      if(ha!=0x20 && hb!=0x40 && hc==0x80)  //001
	   	        	      {
	   	        	     	  GPIOPinWrite(GPIO_PORTD_BASE,GPIO_PIN_2, false);
	   	        	     	  GPIOPinWrite(GPIO_PORTD_BASE,GPIO_PIN_1, false);
	   	        	     	  GPIOPinWrite(GPIO_PORTD_BASE,GPIO_PIN_3, false);
	   	        	     	  GPIOPinWrite(GPIO_PORTE_BASE,GPIO_PIN_1, false);
	   	        	     	  GPIOPinWrite(GPIO_PORTD_BASE,GPIO_PIN_0, GPIO_PIN_0);
	   	        	     	  GPIOPinWrite(GPIO_PORTE_BASE,GPIO_PIN_2, GPIO_PIN_2);
	   	        	     	}
	   	        	      if(ha==0x20 && hb!=0x40 && hc==0x80)  //101
	   	        	      {
	   	        	        	  GPIOPinWrite(GPIO_PORTD_BASE,GPIO_PIN_1, false);
	   	        	        	  GPIOPinWrite(GPIO_PORTD_BASE,GPIO_PIN_2, false);
	   	        	        	  GPIOPinWrite(GPIO_PORTD_BASE,GPIO_PIN_3, false);
	   	        	        	  GPIOPinWrite(GPIO_PORTE_BASE,GPIO_PIN_2, false);
	   	        	        	  GPIOPinWrite(GPIO_PORTD_BASE,GPIO_PIN_0, GPIO_PIN_0);
	   	        	        	  GPIOPinWrite(GPIO_PORTE_BASE,GPIO_PIN_1, GPIO_PIN_1);
	   	        	        	}
	   	        	      if(ha==0x20 && hb!=0x40 && hc!=0x80)  //100
	   	        	      {
	   	        	           	  GPIOPinWrite(GPIO_PORTD_BASE,GPIO_PIN_1, false);
	   	        	           	  GPIOPinWrite(GPIO_PORTD_BASE,GPIO_PIN_0, false);
	   	        	           	  GPIOPinWrite(GPIO_PORTD_BASE,GPIO_PIN_3, false);
	   	        	           	  GPIOPinWrite(GPIO_PORTE_BASE,GPIO_PIN_2, false);
	   	        	           	  GPIOPinWrite(GPIO_PORTD_BASE,GPIO_PIN_2, GPIO_PIN_2);
	   	        	           	  GPIOPinWrite(GPIO_PORTE_BASE,GPIO_PIN_1, GPIO_PIN_1);
	   	        	           	}
   }
}
void PortFInit(void){
	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOF);
	SysCtlDelay(3);
	GPIOPinTypeGPIOInput(GPIO_PORTF_BASE,GPIO_PIN_4);
	GPIOPinTypeGPIOOutput(GPIO_PORTF_BASE,GPIO_PIN_3);
	GPIO_PORTF_PUR_R |= 0x10;     //     enable weak pull-up on PF4
	GPIOIntTypeSet(GPIO_PORTF_BASE,GPIO_PIN_4,GPIO_FALLING_EDGE);
	IntEnable(INT_GPIOF);
	GPIOIntEnable(GPIO_PORTF_BASE, GPIO_INT_PIN_4);
}

void PortFIntHandler(void){
  GPIO_PORTF_ICR_R = 0x10;      // acknowledge flag4
  Old_Count=New_Count;
    New_Count=TimerValueGet(TIMER0_BASE, TIMER_A);
    if(New_Count>Old_Count)
    {
    Elapsed_Count=New_Count-Old_Count;
    freq=79901869.00/Elapsed_Count;
    speed=freq*15.00;
    }
}
